<?php get_header(); ?>
<div id="content" class="site-content">
	<div class="py-2"> 
		<div class="container py-1">
			<ul id="breadcrumb" class="breadcrumb">
				<li class="breadcrumb-item home"><a href="<?php echo esc_url( home_url( '/' ) ); ?>" title="Home">Home</a></li>
				<li class="breadcrumb-item active"><?php global $opt_themes; if($opt_themes['exthemes_News']){ ?><?php echo $opt_themes['exthemes_News']; ?><?php } ?></li>
			</ul>
		</div>
	</div>
	<div class="container">
		<main id="primary" class="content-area">
		<h1 class="h5 font-weight-semibold mb-3">
			<span class="border-bottom-2 border-secondary d-inline-block pb-1">
				<?php global $opt_themes; if($opt_themes['exthemes_News']){ ?><?php echo $opt_themes['exthemes_News']; ?><?php } ?>
			</span>
		</h1>
		<div class="mb-4">
			<?php ex_themes_banner_header_ads_(); ?>
		</div>
		<div class="row">
			<?php $postcounter = 1; if(have_posts()) : ?>
			<?php while(have_posts()) : $postcounter = $postcounter + 1; the_post(); $do_not_duplicate = $post->ID; $the_post_ids = get_the_ID(); ?>
			<div class="col-12 col-sm-6 col-lg-4 mb-4 ">
				<a class="embed-responsive embed-responsive-16by9 bg-cover d-block" style="background-image: url(<?php $image_id = get_post_thumbnail_id(); $image_url = wp_get_attachment_image_src($image_id,'80', true); echo $image_url[0]; ?>); box-shadow: 0 0.125rem 0.25rem rgba(0, 0, 0, 0.15);" href="<?php the_permalink() ?>">
					<div class="d-flex align-items-end p-3 position-absolute" style="background-color: rgba(0, 0, 0, 0.5); top: 0; bottom: 0; left: 0; right: 0;">
						<h3 class="text-white mb-0" style="font-size: 0.875rem;"><?php the_title(); ?></h3>
					</div>
				</a>
			</div>
			<?php endwhile; ?>	
			<?php else : ?>
		</div>
		<p style="text-align:center;padding:10px;">Ready to publish your first post? <a href="<?php echo esc_url( admin_url( 'post-new.php' ) ); ?>">Get started here</a></p>
		<?php endif; ?>
	</div>
	<section class="mb-4">
		<h2 class="h5 font-weight-semibold mb-3">
			<span class="border-bottom-2 border-secondary d-inline-block pb-1">
				Tags </span>
		</h2>
		<div class="d-flex flex-wrap">
			<?php
			$argsx = array( 'taxonomy' => 'news_tags',  'order' => 'ASC' );
			$categoriesx = get_categories( $argsx );
			$terms = get_the_terms($post->ID, 'news_tags');
			if(! empty($categoriesx)){
				foreach($categoriesx as $term){
					$url = get_term_link($term->slug, 'news_tags');
					print "<span class=\"btn btn-light mr-2 mb-2\"><a href='#{$url}'>{$term->name}</a></span>";
				}
			}
			?>
		</div>
	</section>
	</main>
</div>
</div>
</div>
<?php get_footer(); ?>