<?php         
/*
add_action( 'wp_dashboard_setup', 'ci_dashboard_add_widgets' );
function ci_dashboard_add_widgets()
{
	wp_add_dashboard_widget( 'dw_dashboard_widget_news', __( 'Server Info', 'dw' ), 'wds_debugs' );
}

function wds_debugs()
{ ?>
<?php echo get_num_queries(); ?> queries in <?php timer_stop(1); ?> seconds<br />
Server load: <?php $load = sys_getloadavg(); echo $load[0]; ?>%<br />
Memory usage:
<?php $mem_usage = memory_get_usage(true);
if ($mem_usage < 1024)
	echo $mem_usage." bytes";
elseif ($mem_usage < 1048576)
echo round($mem_usage/1024,2)." kilobytes";
else
	echo round($mem_usage/1048576,2)." megabytes";
?><br />
PHP v<?php echo phpversion(); ?><br />
Server date: <?php echo date('Y/j/m'); ?><br />
Server time: <?php echo date('h:i:s a'); ?>
<?php
}
*/

add_filter('admin_menu', 'admin_menu_filter',500);
function admin_menu_filter()
{
	if (current_user_can('editor')) {
		//administrator
		remove_submenu_page( 'themes.php', 'themes.php?page=exthemes' );
		remove_submenu_page( 'themes.php', 'exthemes' );
		remove_submenu_page( 'themes.php', 'widgets.php' );//widget
		remove_submenu_page( 'themes.php', 'theme-editor.php'); //editor
		remove_submenu_page( 'themes.php', 'theme_options' ); //theme-option
		remove_submenu_page( 'themes.php', 'customize.php?return=%2Fwordpress%2Fwp-admin%2Fnav-menus.php' ); // hide the customize submenu
		$customizer_url = add_query_arg( 'return', urlencode( remove_query_arg( wp_removable_query_args(), wp_unslash( $_SERVER['REQUEST_URI'] ) ) ), 'customize.php' );
		remove_submenu_page( 'themes.php', $customizer_url );
		remove_menu_page( 'edit-comments.php' );
		remove_menu_page( 'themes.php' );                 //Appearance
		remove_menu_page( 'plugins.php' );                //Plugins
		remove_menu_page( 'users.php' );                  //Users
		remove_menu_page( 'tools.php' );                  //Tools
		remove_menu_page( 'options-general.php' );        //Settings
		remove_menu_page( 'index.php' );                  //Dashboard
		remove_menu_page( 'upload.php' );
		remove_submenu_page( 'admin.php', 'admin.php?page=_options&tab=10' ); //admin.php?page=_options&tab=10
		remove_submenu_page( 'admin.php', '?page=_options&tab=10' ); //admin.php?page=_options&tab=10
		remove_submenu_page( 'admin.php', '_options&tab=10' ); //admin.php?page=_options&tab=10
		remove_submenu_page( 'admin.php', 'page=_options&tab=10' ); //admin.php?page=_options&tab=10
?>
<style>
	.redux-container .redux-action_bar {
		display: none;
	}
</style>
<?php }
}

// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
add_action('wp_dashboard_setup', 'my_dashboard_widgets');
function my_dashboard_widgets()
{
	global $wp_meta_boxes;
	unset(
	$wp_meta_boxes['dashboard']['normal']['core']['dashboard_plugins'],
	$wp_meta_boxes['dashboard']['side']['core']['dashboard_secondary'],
	$wp_meta_boxes['dashboard']['side']['core']['dashboard_primary']
	);
	wp_add_dashboard_widget( 'dashboard_custom_feed', 'Latest Blog' , 'dashboard_custom_feed_output' );
}
function dashboard_custom_feed_output()
{
	echo '<div class="rss-widget">';
	wp_widget_rss_output(array(
	'url' => 'https://exthem.es/blog/feed/',
	'title' => 'Latest Blog',
	'items' => 5,
	'show_summary' => 1,
	'show_author' => 1,
	'show_date' => 1
	));
	echo '</div>';
}

// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function exthemes_wp_dashboard_setup()
{
	// Add custom dashbboard widget.
	add_meta_box(
	'dashboard_widget_kentooz',
	__( 'Exthem.es News Info', EX_THEMES_NAMES2_ ),
	'exthemes_render_dashboard_widget',
	'dashboard',
	'normal',  // $context: 'advanced', 'normal', 'side', 'column3', 'column4'
	'high'  // $priority: 'high', 'core', 'default', 'low'
	);
}
add_action( 'wp_dashboard_setup', 'exthemes_wp_dashboard_setup' );
if ( ! function_exists( 'exthemes_get_banner_widget' ) )
	:
/**
* Get json data banner
*
* @since 1.0.0
* @param int $cache Cache.
* @return array
*/
function exthemes_get_banner_widget( $cache = 168 )
{
	if ( false === ( $result = get_transient( 'exthemes_cache_json_banner_' . $cache ) ) ) {
		$response = wp_remote_get(
		''.EXTHEMES_API_URL.'/idasboard.json',
		array(
		'timeout'   => 120,
		'sslverify' => false,
		)
		);
		if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {
			if ( is_wp_error( $response ) ) {
				$result = false;
			} else {
				$result = false;
			}
		} else {
			$data = json_decode( wp_remote_retrieve_body( $response ), true );
			if ( ! empty( $data ) && is_array( $data ) ) {
				$result = $data;
			} else {
				$result = false;
			}
		}
		set_transient( 'exthemes_cache_json_banner_' . $cache, $result, $cache * HOUR_IN_SECONDS );
	}
	return $result;
}
endif;
/**
* Render widget.
*/
function exthemes_render_dashboard_widget()
{
	$cache = 168;
	$data_array = exthemes_get_banner_widget( $cache );
	if ( false !== $data_array && ! empty( $data_array ) && is_array( $data_array ) ) {
		$imagebanner    = $data_array['bannerimage'];
		$imagebannerurl = $data_array['urlbannerimage'];
		if ( ! empty( $imagebanner ) && isset( $imagebanner ) && ! empty( $imagebannerurl ) && isset( $imagebannerurl ) ) {
			echo '<div style="margin: -13px -13px 15px;">';
			echo '<a href="' . esc_url( $imagebannerurl ) . '?utm_medium=dashboard&utm_source='.EX_THEMES_NAMES2_.'" rel="nofollow" target="_blank"><img src="' . esc_url( $imagebanner ) . '" style="display:block;width:100%;" loading="lazy" /></a>';
			echo '</div>';
		}
		$themeterbaru = $data_array['newtheme'];
		if ( is_array( $themeterbaru ) ) {
			echo '<div id="published-posts">';
			echo '<h3>New Themes</h3>';
			echo '<ul>';
			foreach ( $themeterbaru as $value ) {
				if ( ! empty( $value['url'] ) && isset( $value['url'] ) && ! empty( $value['title'] ) && isset( $value['title'] ) ) {
					echo '<li><a href="' . esc_url( $value['url'] ) . '?utm_medium=dashboard&utm_source='.EX_THEMES_NAMES2_.'" rel="nofollow" target="_blank">' . esc_attr( $value['title'] ) . '</a></li>';
				}
			}
			echo '</ul></div>';
		}
	} else {
		echo '<p>No News</p>';
		delete_transient( 'exthemes_cache_json_banner_' . $cache );
	}
	echo '<p class="community-events-footer" style="margin: 0 -12px -12px !important;background-color: #efefef;">';
	echo '<a href="'.EXTHEMES_API_URL.'/login/?utm_medium=dashboard&utm_source='.EX_THEMES_NAMES2_.'" target="_blank" rel="nofollow">Login Memberarea <span class="screen-reader-text">(opens in a new tab)</span><span aria-hidden="true" class="dashicons dashicons-external"></span></a>';
	echo ' | ';
	echo '<a href="https://web.facebook.com/ex.themescom" target="_blank" rel="nofollow">FB Group '.EXTHEMES_SLUG.'<span class="screen-reader-text">(opens in a new tab)</span><span aria-hidden="true" class="dashicons dashicons-external"></span></a>';
	echo '</p>';
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function rgb($hex, $asString = true)
{
// strip off any leading #
if (0 === strpos($hex, '#')) {
$hex = substr($hex, 1);
} else if (0 === strpos($hex, '&H')) {
$hex = substr($hex, 2);
}      

// break into hex 3-tuple
$cutpoint = ceil(strlen($hex) / 2)-1;
$rgb = explode(':', wordwrap($hex, $cutpoint, ':', $cutpoint), 3);

// convert each tuple to decimal
$rgb[0] = (isset($rgb[0]) ? hexdec($rgb[0]) : 0);
$rgb[1] = (isset($rgb[1]) ? hexdec($rgb[1]) : 0);
$rgb[2] = (isset($rgb[2]) ? hexdec($rgb[2]) : 0);

return ($asString ? "rgba({$rgb[0]},{$rgb[1]},{$rgb[2]}, 0.1)" : $rgb);
/* rgba(0,128,128, 0.1) */
}
/*-----------------------------------------------------------------------------------*/ 
