<?php
function news() {
    $labels = array(
        'name'                => _x( 'News', 'Post Type General Name', 'text_domain' ),
        'singular_name'       => _x( 'News', 'Post Type Singular Name', 'text_domain' ),
        'menu_name'           => __( 'News', 'text_domain' ),
        'parent_item_colon'   => __( 'Parent News:', 'text_domain' ),
        'all_items'           => __( 'All News', 'text_domain' ),
        'view_item'           => __( 'View News Info', 'text_domain' ),
        'add_new_item'        => __( 'Add New Article', 'text_domain' ),
        'add_new'             => __( 'Add News', 'text_domain' ),
        'edit_item'           => __( 'Edit News Info', 'text_domain' ),
        'update_item'         => __( 'Update News Info', 'text_domain' ),
        'search_items'        => __( 'Search News', 'text_domain' ),
        'not_found'           => __( 'Not found', 'text_domain' ),
        'not_found_in_trash'  => __( 'Not found in Trash', 'text_domain' ),
    );
    $rewrite = array(
        'slug'                => 'news',
        'with_front'          => true,
        'pages'               => true,
        'feeds'               => true,
    );
    $args = array(
        'label'               => __( 'News', 'text_domain' ),
        'description'         => __( 'Info News', 'text_domain' ),
        'labels'              => $labels,
		'show_in_rest'       => true, // To use Gutenberg editor.

        'supports'            => array( 'title', 'editor', 'thumbnail', 'comments'),
        'hierarchical'        => false,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 7,
        'menu_icon'           => 'dashicons-admin-post',
        'can_export'          => true,
        'has_archive'         => true,
        'exclude_from_search' => false,
        'publicly_queryable'  => true,
        'capability_type'     => 'page',
        'rewrite'             => $rewrite,
    );
    register_post_type( 'news', $args );
}
add_action( 'init', 'news', 0 );
function news_tags_taxonomy() { $news_tags = array(
    'name' => _x( 'News Tags', 'taxonomy general name' ),
    'singular_name' => _x( 'News Tag', 'taxonomy singular name' ),
    'search_items' => __( 'Search News Tags' ),
    'popular_items' => __( 'Popular News Tags' ),
    'all_items' => __( 'All News Tags' ),
    'parent_item' => null,
    'parent_item_colon' => null,
    'edit_item' => __( 'Edit News Tag' ),
    'update_item' => __( 'Update News Tag' ),
    'add_new_item' => __( 'Add New News Tag' ),
    'new_item_name' => __( 'New News Tag Name' ),
    'separate_items_with_commas' => __( 'Separate News tags with commas' ),
    'add_or_remove_items' => __( 'Add or remove News tags' ),
    'choose_from_most_used' => __( 'Choose from the most used News tags' ),
    'menu_name' => __( 'News Tags' ), );
    register_taxonomy('news_tags','news', array(
        'hierarchical' => false,
        'labels' => $news_tags,
        'show_ui' => true,
		'show_in_rest'       => true, 
        'show_admin_column' => true,
        'update_count_callback' => '_update_post_term_count',
        'query_var' => true,
        'rewrite' => array(
            'slug' => 'news_tags' ),
    ));
}
add_action( 'init', 'news_tags_taxonomy', 0 );
function news_categories_taxonomy() {
    $label = array(
        'name' => _x( 'News Categories', 'taxonomy general name' ),
        'singular_name' => _x( 'News Category',
            'taxonomy singular name' ), 'search_items' => __( 'Search news Categories' ),
        'all_items' => __( 'All News Categories' ),
        'parent_item' => __( 'Parent News Category' ),
        'parent_item_colon' => __( 'Parent News Category:' ),
        'edit_item' => __( 'Edit News Category' ),
        'update_item' => __( 'Update News Category' ),
        'add_new_item' => __( 'Add New News Category' ),
        'new_item_name' => __( 'New News Category' ),
        'menu_name' => __( 'News Categories' ),
    );
    register_taxonomy(
        'news_categories',array('news'), array(
        'hierarchical' => true,
        'labels' => $label,
		'show_in_rest'       => true, 
        'show_ui' => true,
        'show_admin_column' => true,
        'query_var' => true,
        'rewrite' => array(
            'slug' => 'news_categories' ),
    ));
}
add_action( 'init', 'news_categories_taxonomy', 0 );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_taxonomies_() {
	$labels = array(
		'name'              => _x( 'Developer', 'taxonomy general name' ),
		'singular_name'     => _x( 'Developer', 'taxonomy singular name' ),
		'search_items'      => __( 'Search Developer' ),
		'all_items'         => __( 'All Developer' ),
		'parent_item'       => __( 'Parent Developer' ),
		'parent_item_colon' => __( 'Parent Developer:' ),
		'edit_item'         => __( 'Edit Developer' ),
		'update_item'       => __( 'Update Developer' ),
		'add_new_item'      => __( 'Add New Developer' ),
		'new_item_name'     => __( 'New Developer Name' ),
		'menu_name'         => __( 'Developer' ),
	);
	$args = array(
		'hierarchical'      => false,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'update_count_callback' => '_update_post_term_count',
		'query_var'         => true,		
		'show_in_rest'        => true,
		'rewrite'           => array( 'slug' => 'developer' ),
	);
	register_taxonomy( 'developer', array( 'post' ), $args );
}
add_action( 'init', 'ex_themes_taxonomies_', 0 );