<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
if ( ! function_exists( 'moddroid_setup' ) ) :
    function moddroid_setup() {       
        add_theme_support( 'automatic-feed-links' );
        add_theme_support( 'title-tag' );
        add_theme_support( 'post-thumbnails' );
        // This theme uses wp_nav_menu() in one location.
        /*
		register_nav_menus( array(
            'main-menu' => __( 'Header' ),
            'footer-lf' => __( 'Footer Left' ),
            'footer-rh' => __( 'Footer Right' )
        ));
		*/
        function register_my_menu() {
            register_nav_menu('menu_header',__( 'Header', 'ex_themes_' ));
            register_nav_menu('footer-lf',__( 'Footer Left', 'ex_themes_' ));
            register_nav_menu('footer-rh',__( 'Footer Right', 'ex_themes_' ));
        }
        add_action( 'init', 'register_my_menu' );
        add_action('after_switch_theme', 'theme_activation_function', 10 ,  2);
        function theme_activation_function ($oldname, $oldtheme = false) {
            $menus = array(
                'Header'  => array(
                    'home'  => 'Home',
                    'top-apps'  => 'Top Apps',
                    'top-games'  => 'Top Games',
                    'top-paids'  => 'Paid for free'),
                'Footer Left' => array(
                    'about' => 'About'
                ),
                'Footer Right' => array(
                    'contact'  => 'Contact',
                    'privacy-policy'  => 'Privacy',
                    'dmca'  => 'DMCA',
                    'advertising'  => 'Advertising',
                    'sitemap'  => 'Sitemap'
                )
            );
            foreach($menus as $menuname => $menuitems) {
                $menu_exists = wp_get_nav_menu_object($menuname);
                // If it doesn't exist, let's create it.
                if ( !$menu_exists) {
                    $menu_id = wp_create_nav_menu($menuname);
                    foreach($menuitems as $slug => $item) {
                        wp_update_nav_menu_item(
                            $menu_id, 0, array(
                                'menu-item-title'  => $item,
                                'menu-item-url'     => '',
                                'menu-item-status'  => 'publish'
                            )
                        );
                    }}}
        }
		/*
		 * Make theme available for translation.
		 * Translations can be filed in the /languages/ directory.
		 * If you're building a theme based on Twenty Twenty, use a find and replace
		 * to change 'twentytwenty' to the name of your theme in all the template files.
		 */
		 
		load_theme_textdomain( 'moddroid', get_template_directory() . '/languages' );
        /*
        //Get all locations (including the one we just created above)
            $locations = get_theme_mod('nav_menu_locations');
            //set the menu to the new location and save into database
            $locations[$menus] = $menu_id;
            set_theme_mod( 'nav_menu_locations', $locations );
        */
        /*
         * Switch default core markup for search form, comment form, and comments
         * to output valid HTML5.
         */
        add_theme_support( 'html5', array(
            'search-form',
            'comment-form',
            'comment-list',
            'gallery',
            'caption',
        ) );
        // Add theme support for selective refresh for widgets.
         
        // Image Sizes
        add_image_size( '64', 64, 64, true );
        add_image_size( '120', 120, 120, true );
        if( get_option( 'notification_exthemes_1' ) != true ) {
        add_action( 'admin_notices', 'admin_notice_update_exthemes' );
        }
    }
endif;
add_action( 'after_setup_theme', 'moddroid_setup' );
// One click demo import
function moddroid_import_files() {
  	return array(
		array(
			'import_file_name'             => 'Demo Import ', 	
			'local_import_file' => trailingslashit( get_template_directory() ) . 'demo/demo.xml',
			'local_import_widget_file'     => trailingslashit( get_template_directory() ) . 'demo/widgets.wie',
			 
			'local_import_redux'           => array(
				array(
				  'file_path'   => trailingslashit( get_template_directory() ) . 'demo/redux.json',
				  'option_name' => 'opt_themes',
				),
			  ),
			'import_preview_image_url'     => 'https://extheme.cc/demo/moddroid/wp-content/themes/apkfab/screenshot.png',
			'preview_url'                  => 'https://extheme.cc/demo/moddroid/',
		),
		array(
			'import_file_name'             => 'Demo Import ', 
		),
	);
}

add_filter( 'pt-ocdi/import_files', 'moddroid_import_files' );

// Default Home and Blog Setup
function moddroid_after_import_setup() {
    // Assign menus to their locations.
    $main_menu = get_term_by( 'name', 'Header', 'menu_header' );

    set_theme_mod( 'nav_menu_locations', array(
            'main_menu' => $main_menu->term_id,
        )
    );

    // Assign front page and posts page (blog page).
    $front_page_id = get_page_by_title( 'Home' );
    $blog_page_id  = get_page_by_title( 'Blog' );

    update_option( 'show_on_front', 'page' );
    update_option( 'page_on_front', $front_page_id->ID );
    update_option( 'page_for_posts', $blog_page_id->ID );

}
add_action( 'pt-ocdi/after_import', 'moddroid_after_import_setup' );

// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'id' => 'editor-choices',
        'name'=> ''.EX_THEMES_NAMES_.' Slider Home',
        'description'   => __( 'Widgets in this area will be shown on Slider Home', 'moddroid' ),
        'before_widget' => '<section class="mb-2">',
        'after_widget' => '</section>',
        'before_title' => '<h2 class="h5 font-weight-semibold mb-3"><span class="border-bottom-2 border-secondary d-inline-block pb-1">',
        'after_title' => '</span></h2><div style="clear:both"></div>',
));
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'id' => 'home-popular',
        'name'=> ''.EX_THEMES_NAMES_.' Home Post',
		'description'   => __( 'Widgets in this area will be shown only Home Post', 'moddroid' ),
        'before_widget' => '<section class="mb-2">',
        'after_widget' => '</section>',
        'before_title' => '<h2 class="h5 font-weight-semibold mb-3"><span class="border-bottom-2 border-secondary d-inline-block pb-1">',
        'after_title' => '</span></h2><div style="clear:both"></div>',
));
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'id' => 'sidebar-home-1',
        'name'=>''.EX_THEMES_NAMES_.' Sidebar Home Top',
		'description'   => __( 'Widgets in this area will be shown on sidebar only Home Top.', 'moddroid' ),
        'before_widget' => '<section class="mb-2">',
        'after_widget' => '</section>',
        'before_title' => '<h2 class="h5 font-weight-semibold mb-3"><span class="border-bottom-2 border-secondary d-inline-block pb-1">',
        'after_title' => '</span></h2><div style="clear:both"></div>',
));
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'id' => 'sidebar-home-2',
        'name'=>''.EX_THEMES_NAMES_.' Sidebar Home Bottom',
		'description'   => __( 'Widgets in this area will be shown on sidebar only Home Bottom.', 'moddroid' ),
        'before_widget' => '<section class="mb-2">',
        'after_widget' => '</section>',
        'before_title' => '<h2 class="h5 font-weight-semibold mb-3"><span class="border-bottom-2 border-secondary d-inline-block pb-1">',
        'after_title' => '</span></h2><div style="clear:both"></div>',
));
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'id' => 'sidebar-1',
        'name'=> ''.EX_THEMES_NAMES_.' Sidebar Post',
		'description'   => __( 'Widgets in this area will be shown on sidebar Post', 'moddroid' ),
        'before_widget' => '<section class="mb-2">',
        'after_widget' => '</section>',
        'before_title' => '<h2 class="h5 font-weight-semibold mb-3"><span class="border-bottom-2 border-secondary d-inline-block pb-1">',
        'after_title' => '</span></h2><div style="clear:both"></div>',
));
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function remove_footer_admin ()
{ 
	$linkX = get_bloginfo('url'); $parse = parse_url($linkX); $sitex = $parse['host'];
    echo '<p><span id="footer-thankyou" style="font-style:normal;font-size:90%;letter-spacing:1px;"><b style="color:crimson;background: url('.EX_THEMES_URI.'/assets/img/sparks.gif);text-transform: uppercase !important;">'.$sitex.'</b> using <b style="color:crimson;background: url('.EX_THEMES_URI.'/assets/img/sparks.gif); ">'.EXTHEMES_NAME.' v.'.EXTHEMES_VERSION.' </b> @<script type="text/javascript">var creditsyear = new Date();document.write(creditsyear.getFullYear());</script> - Developed by <a href="'.EXTHEMES_API_URL.'" title="Premium Wordpress Themes" target="_blank"  style="color:crimson;background: url('.EX_THEMES_URI.'/assets/img/sparks.gif);text-transform: uppercase !important;">'.EXTHEMES_AUTHOR.'</a></span></p>';
}
add_filter('admin_footer_text', 'remove_footer_admin');
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_notices_inactivate() {
    if(empty($lis) && ($_GET['page'] != EX_THEMES_SLUGS_) ) {
        printf('<style>.notice-error, div.error {border-left-color:deepskyblue!important;}.landingpress-message {padding: 20px !important;font-size:16px!important;}.landingpress-message-inner {overflow:hidden;}.landingpress-message-icon {float:left;width:35px;height:35px;padding-right:20px;}.landingpress-message-button {float:right;padding:3px 0 0 20px;}</style><div class="error landingpress-message"><div class="landingpress-message-inner"><div class="landingpress-message-icon" style="font-size:16px!important;text-transform:capitalize"><img src="'.get_template_directory_uri().'/assets/img/xthemes.png" width="35" height="35" alt=""/></div><div class="landingpress-message-button"><a href="'.admin_url('admin.php?page='.EX_THEMES_SLUGS_.'').'" class="button button-primary">Enter License Code </a></div><strong style="text-transform:capitalize;  ">Welcome to '.EX_THEMES_NAMES_.' WordPress Themes.</strong> <strong style="text-transform:capitalize;font-weight:800;font-size:20px;color:orangered!important; text-shadow:.02em .05em 0 rgba(0,0,0,0.4);">Please Activate '.EX_THEMES_NAMES_.' license</strong> <br><i style="text-transform:capitalize; ">to get automatic updates, technical support, and access to '.EX_THEMES_NAMES_.' Options Panel</i> .</div></div>');
    }
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_not_activate_noticex() { ?>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>body{background:#000!important;overflow:hidden}#warning span{font-size:50px}#warning{z-index:999999999;position:fixed;top:0;right:0;left:0;padding:20% 0;height:100%;text-align:center;background:rgba(39,2,23, 0.97);color:#fff}h4.ex_themes, a.ex_themes {font-weight: 800;font-size: 40px;color: #ffd800 !important;line-height: 1.3em;text-align: center;text-shadow: 0.02em 0.05em 0em rgba(0,0,0,0.4);}</style><div id="warning"><h4 class="ex_themes"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> Need Activate Themes <i class="fa fa-exclamation-triangle" aria-hidden="true"></i></h4><p>Please Contact <b><a class="ex_themes" href="https://exthem.es" target="_blank">exthem.es</a></b> to get license key</p><span id="aktivasi"> </span></div>
<?php }
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function catch_that_image() {
    global $post, $posts, $opt_themes;
    $first_img = '';
    ob_start();
    ob_end_clean();
    $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
    $first_img = $matches [1] [0];
    if(empty($first_img)){ //Defines a default image
        $first_img = $opt_themes['ex_themes_defaults_no_images_']['url'];
    }
    return $first_img;
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function timeago($ptime) {
	global $opt_themes;
	$just_now = $opt_themes['exthemes_apk_days_1'];
	$years_ago = $opt_themes['exthemes_apk_days_2'];
	$months_ago = $opt_themes['exthemes_apk_days_3'];
	$weeks_ago = $opt_themes['exthemes_apk_days_4'];
	$days_ago = $opt_themes['exthemes_apk_days_5'];
	$hours_ago = $opt_themes['exthemes_apk_days_6'];
	$minutes_ago = $opt_themes['exthemes_apk_days_7'];
	$seconds_ago = $opt_themes['exthemes_apk_days_8'];
    $ptime = strtotime($ptime);
    $etime = time() - $ptime;
    if($etime < 1) return $just_now;
    $interval = array (
        12 * 30 * 24 * 60 * 60 => ' '.$years_ago.' ('.date('F j, Y', $ptime).')',
        30 * 24 * 60 * 60 => ' '.$months_ago.' ('.date('F j, Y', $ptime).')',
        7 * 24 * 60 * 60 => ' '.$weeks_ago.' ('.date('F j, Y', $ptime).')',
        24 * 60 * 60 => $days_ago,
        60 * 60 => $hours_ago,
        60 => $minutes_ago,
        1 => $seconds_ago );
    foreach ($interval as $secs => $str) {
        $d = $etime / $secs;
        if ($d >= 1) {
            $r = round($d);
            return $r . $str;
        }
    }; 
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_get_post_view_() {
    $count = get_post_meta( get_the_ID(), 'post_views_count', true );
    if($count=='') {
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
        return "0";
    }
    if ($count > 1000) {
        return round ( $count / 1000 , 1 ).'K';
    } else {
        return $count.'';
    }
    //return "$count";
}
function ex_themes_set_post_view_() {
    $key = 'post_views_count';
    $post_id = get_the_ID();
    $count = (int) get_post_meta( $post_id, $key, true );
    $count++;
    update_post_meta( $post_id, $key, $count );
}
function ex_themes_posts_column_views_( $columns ) {
    $columns['post_views'] = 'Views';
    return $columns;
}
function ex_themes_posts_custom_column_views_( $column ) {
    if ( $column === 'post_views') {
        echo ex_themes_get_post_view_();
    }
}
add_filter( 'manage_posts_columns', 'ex_themes_posts_column_views_' );
add_action( 'manage_posts_custom_column', 'ex_themes_posts_custom_column_views_' );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function wpb_set_post_views($postID) {
    $count_key = 'wpb_post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        $count = 0;
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
    }
    if ($count > 1000) {
        return round ( $count / 1000 , 1 ).'K';
    } else{
        $count++;
        update_post_meta($postID, $count_key, $count);
    }
}
remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function wpb_track_post_views ($post_id) {
    if ( !is_single() ) return;
    if ( empty ( $post_id) ) {
        global $post;
        $post_id = $post->ID;
    }
    wpb_set_post_views($post_id);
}
add_action( 'wp_head', 'wpb_track_post_views');
function wpb_get_post_views($postID){
    $count_key = 'wpb_post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
        return "0 View";
    }
    if ($count > 1000) {
        return round ( $count / 1000 , 1 ).'K Views';
    } else {
        return $count.' Views';
    }
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_duplicate_scripts( $hook ) {
    if( !in_array( $hook, array( 'post.php', 'post-new.php' , 'edit.php'))) return;
    wp_enqueue_script('duptitles',
        wp_enqueue_script('duptitles',EX_THEMES_URI.'/assets/js/psy_duplicate.js',
            array( 'jquery' )), array( 'jquery' )  );
}
add_action( 'admin_enqueue_scripts', 'ex_themes_duplicate_scripts', 2000 );
add_action('wp_ajax_ex_themes_duplicate', 'ex_themes_duplicate_callback'); 
function ex_themes_duplicate_callback() {
    function ex_themes_results_checks() {
        global $wpdb;
        $title = $_POST['post_title'];
        $post_id = $_POST['post_id'];
        $titles = "SELECT post_title FROM $wpdb->posts WHERE post_status = 'publish' AND post_title = '{$title}' AND ID != {$post_id} ";
        $results = $wpdb->get_results($titles);
        if($results) {
            return '<div class="error"><p><span class="dashicons dashicons-warning"></span> '. __( 'This content already exists, we recommend not to publish.' , 'moddroid' ) .' </p></div>';
        } else {
            return '<div class="notice rebskt updated"><p><span class="dashicons dashicons-thumbs-up"></span> '.__('Excellent! this content is unique.' , 'moddroid').'</p></div>';
        }
    }
    echo ex_themes_results_checks();
    die();
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
add_rewrite_endpoint( 'download', EP_PERMALINK | EP_PAGES );
function ex_themes_download() {
    add_rewrite_endpoint( 'download', EP_PERMALINK | EP_PAGES );
}
add_action( 'init', 'ex_themes_download' );
function ex_themes_download_template() {
    global $wp_query;
    // if this is not a request for play or a singular object then bail
    if ( ! isset( $wp_query->query_vars['download'] ) || ! is_singular() )
        return;
    // include custom template
    include get_template_directory().'/template/download.php';
    exit;
}
add_action( 'template_redirect', 'ex_themes_download_template' );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
add_rewrite_endpoint( 'get', EP_PERMALINK | EP_PAGES );
function ex_themes_get() {
    add_rewrite_endpoint( 'get', EP_PERMALINK | EP_PAGES );
}
add_action( 'init', 'ex_themes_get' );
function ex_themes_get_template() {
    global $wp_query;
    // if this is not a request for play or a singular object then bail
    if ( ! isset( $wp_query->query_vars['get'] ) || ! is_singular() )
        return;
    // include custom template
    include get_template_directory().'/template/get.php';
    exit;
}
add_action( 'template_redirect', 'ex_themes_get_template' );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
add_rewrite_endpoint( 'file', EP_PERMALINK | EP_PAGES );
function ex_themes_files() {
    add_rewrite_endpoint( 'file', EP_PERMALINK | EP_PAGES );
}
add_action( 'init', 'ex_themes_files' );
function ex_themes_files_template() {
    global $wp_query;
    // if this is not a request for play or a singular object then bail
    if ( ! isset( $wp_query->query_vars['file'] ) || ! is_singular() )
        return;
    // include custom template
    include get_template_directory().'/template/file.php';
    exit;
}
add_action( 'template_redirect', 'ex_themes_files_template' );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\

function ex_themes_add_img_alt_tag_title_($attr, $attachment = null) {
    $img_title = trim(strip_tags($attachment->post_title));
    if (empty($attr['alt'])) {
        $attr['alt'] = $img_title;
        $attr['title'] = $img_title;
    }
    return $attr;
}
add_filter('wp_get_attachment_image_attributes', 'ex_themes_add_img_alt_tag_title_', 10, 2);
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_page_navy_($pages = '', $range = 1)
{
    $showitems = ($range * 1)+1;
    global $paged;
    if(empty($paged)) $paged = 1;
    if($pages == '')
    {
        global $wp_query;
        $pages = $wp_query->max_num_pages;
        if(!$pages)
        {
            $pages = 1;
        }
    }
    if(1 != $pages)
    {
        if($paged > 1 && $paged > $range+1 && $showitems < $pages) echo "<li class=\"page-item\"><a class='page-link' href='".get_pagenum_link(1)."'><svg class='svg-6' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 192 512'><path d='M4.2 247.5L151 99.5c4.7-4.7 12.3-4.7 17 0l19.8 19.8c4.7 4.7 4.7 12.3 0 17L69.3 256l118.5 119.7c4.7 4.7 4.7 12.3 0 17L168 412.5c-4.7 4.7-12.3 4.7-17 0L4.2 264.5c-4.7-4.7-4.7-12.3 0-17z'></path></svg></a></li>";
        if($paged > 1 && $showitems < $pages) echo "<li class=\"page-item\"><a class='page-link' href='".get_pagenum_link($paged - 1)."'><svg class='svg-6' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 192 512'><path d='M4.2 247.5L151 99.5c4.7-4.7 12.3-4.7 17 0l19.8 19.8c4.7 4.7 4.7 12.3 0 17L69.3 256l118.5 119.7c4.7 4.7 4.7 12.3 0 17L168 412.5c-4.7 4.7-12.3 4.7-17 0L4.2 264.5c-4.7-4.7-4.7-12.3 0-17z'></path></svg></a></li>";
        for ($i=1; $i <= $pages; $i++)
        {
            if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
            {
                echo ($paged == $i)? "<li class=\"page-item active\"><a class='page-link' href='".get_pagenum_link($i)."'>".$i."</a></li>":"<li class=\"page-item\"><a class='page-link' href='".get_pagenum_link($i)."'>".$i."</a></li>";
            }
        }
        if ($paged < $pages && $showitems < $pages) echo "<li class=\"page-item\"><a class='page-link' href=\"".get_pagenum_link($paged + 1)."\" > <svg class='svg-6' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 192 512'><path d='M187.8 264.5L41 412.5c-4.7 4.7-12.3 4.7-17 0L4.2 392.7c-4.7-4.7-4.7-12.3 0-17L122.7 256 4.2 136.3c-4.7-4.7-4.7-12.3 0-17L24 99.5c4.7-4.7 12.3-4.7 17 0l146.8 148c4.7 4.7 4.7 12.3 0 17z'></path></svg></a></li>";
        if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) echo "<li class=\"page-item\"><a class='page-link' href='".get_pagenum_link($pages)."'  ><svg class=\"svg-6\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 384 512\"><path d=\"M363.8 264.5L217 412.5c-4.7 4.7-12.3 4.7-17 0l-19.8-19.8c-4.7-4.7-4.7-12.3 0-17L298.7 256 180.2 136.3c-4.7-4.7-4.7-12.3 0-17L200 99.5c4.7-4.7 12.3-4.7 17 0l146.8 148c4.7 4.7 4.7 12.3 0 17zm-160-17L57 99.5c-4.7-4.7-12.3-4.7-17 0l-19.8 19.8c-4.7 4.7-4.7 12.3 0 17L138.7 256 20.2 375.7c-4.7 4.7-4.7 12.3 0 17L40 412.5c4.7 4.7 12.3 4.7 17 0l146.8-148c4.7-4.7 4.7-12.3 0-17z\"></path></svg></a></li>";
    }
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_blog_shares_($content1) {
    global $wpdb, $post, $opt_themes;
    if(is_singular() || is_home()){
        #### Get current page URL
        $ex_themes_blog_url_shares_ = urlencode(get_permalink());
        $ex_themes_view_1_ = ex_themes_set_post_view_();
        $ex_themes_view_2_ = ex_themes_get_post_view_();
        $ex_themes_fake_views_ = mt_rand(500,9999);
        #### Get current page title
        $ex_themes_blog_title_shares_ = htmlspecialchars(urlencode(html_entity_decode(get_the_title(), ENT_COMPAT, 'UTF-8')), ENT_COMPAT, 'UTF-8');
        $ex_themes_blog_desc_shares_ = htmlspecialchars(urlencode(html_entity_decode( get_post_meta( $post->ID, 'wp_desck_GP', true ) ) ) );
        #### $ex_themes_blog_title_shares_ = str_replace( ' ', '%20', get_the_title());
        #### Get Post Thumbnail for pinterest
        $ex_themes_blog_img_shares_ = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
        #### Construct sharing URL without using any script
        $twitterURL = 'https://twitter.com/intent/tweet?text='.$ex_themes_blog_title_shares_.'&amp;url='.$ex_themes_blog_url_shares_.'&amp;via=iblog.my.id';
        $facebookURL = 'https://www.facebook.com/sharer/sharer.php?u='.$ex_themes_blog_url_shares_;
        $telegramURL = 'https://telegram.me/share/url?text='.$ex_themes_blog_title_shares_.'&url='.$ex_themes_blog_url_shares_.'';
        $bufferURL = 'https://bufferapp.com/add?url='.$ex_themes_blog_url_shares_.'&amp;text='.$ex_themes_blog_title_shares_;
        $linkedInURL = 'https://www.linkedin.com/shareArticle?mini=true&url='.$ex_themes_blog_url_shares_.'&amp;title='.$ex_themes_blog_title_shares_;
        $whatsappURL = 'https://api.whatsapp.com/send?text='.$ex_themes_blog_title_shares_.'%20'.$ex_themes_blog_url_shares_.'';
        $tumblrURL = 'https://www.tumblr.com/widgets/share/tool?posttype=link&title='.$ex_themes_blog_title_shares_.'&caption='.$ex_themes_blog_title_shares_.'&content='.$ex_themes_blog_url_shares_.'&shareSource=tumblr_share_button';
        $vkURL = 'https://vk.com/share.php?url='.$ex_themes_blog_url_shares_.'&title='.$ex_themes_blog_title_shares_.'&description='.$ex_themes_blog_desc_shares_.'&image='.$ex_themes_blog_img_shares_[0].'';
        #### Based on popular demand added Pinterest too
        $pinterestURL = 'https://pinterest.com/pin/create/button/?url='.$ex_themes_blog_url_shares_.'&amp;media='.$ex_themes_blog_img_shares_[0].'&amp;description='.$ex_themes_blog_title_shares_;
        #### Add sharing button at the end of page/page content
        $content1 .= '';
        $content1 .= '<ul class="nav mb-4 list-shares">';
        /*
        if($opt_themes['aktif_fake_views']) {
        $content1 .= '<div class="nc_tweetContainer swp_share_button total_shares total_sharesalt"><span class="swp_count " style="transition: padding 0.1s linear 0s;">'.numToKs($ex_themes_fake_views_).' <span class="swp_label">Reads</span></span></div>';
        } else {
        $content1 .= '<div class="nc_tweetContainer swp_share_button total_shares total_sharesalt"><span class="swp_count " style="transition: padding 0.1s linear 0s;">'.$ex_themes_view_2_.' <span class="swp_label">Reads</span></span></div>';
        }
        */
        $content1 .= '
<li class="mr-2">
   <a class="facebook" href="'.$facebookURL.'" rel="nofollow" target="_blank">
      <svg class="svg-5" fill="#fff" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512">
         <path d="M279.14 288l14.22-92.66h-88.91v-60.13c0-25.35 12.42-50.06 52.24-50.06h40.42V6.26S260.43 0 225.36 0c-73.22 0-121.08 44.38-121.08 124.72v70.62H22.89V288h81.39v224h100.17V288z" />
      </svg>
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="twitter" href="'. $twitterURL .'" rel="nofollow" target="_blank">
      <svg class="svg-5" fill="#fff" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
         <path d="M459.37 151.716c.325 4.548.325 9.097.325 13.645 0 138.72-105.583 298.558-298.558 298.558-59.452 0-114.68-17.219-161.137-47.106 8.447.974 16.568 1.299 25.34 1.299 49.055 0 94.213-16.568 130.274-44.832-46.132-.975-84.792-31.188-98.112-72.772 6.498.974 12.995 1.624 19.818 1.624 9.421 0 18.843-1.3 27.614-3.573-48.081-9.747-84.143-51.98-84.143-102.985v-1.299c13.969 7.797 30.214 12.67 47.431 13.319-28.264-18.843-46.781-51.005-46.781-87.391 0-19.492 5.197-37.36 14.294-52.954 51.655 63.675 129.3 105.258 216.365 109.807-1.624-7.797-2.599-15.918-2.599-24.04 0-57.828 46.782-104.934 104.934-104.934 30.213 0 57.502 12.67 76.67 33.137 23.715-4.548 46.456-13.32 66.599-25.34-7.798 24.366-24.366 44.833-46.132 57.827 21.117-2.273 41.584-8.122 60.426-16.243-14.292 20.791-32.161 39.308-52.628 54.253z" />
      </svg>
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="resp-sharing-button__link" title="Tumblr" href="'. $tumblrURL .'" target="_blank" rel="nofollow noopener" aria-label="">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
         <path d="M13.5.5v5h5v4h-5V15c0 5 3.5 4.4 6 2.8v4.4c-6.7 3.2-12 0-12-4.2V9.5h-3V6.7c1-.3 2.2-.7 3-1.3.5-.5 1-1.2 1.4-2 .3-.7.6-1.7.7-3h3.8z" />
      </svg>
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="pinterest" onclick="var e=document.createElement(\'script\');						e.setAttribute(\'type\',\'text/javascript\');e.setAttribute(\'charset\',\'UTF-8\');						e.setAttribute(\'src\',\'\/\/assets.pinterest.com\/js\/pinmarklet.js?r=\'+Math.random()*99999999);						document.body.appendChild(e);">
      <svg class="svg-5" fill="#fff" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512">
         <path d="M204 6.5C101.4 6.5 0 74.9 0 185.6 0 256 39.6 296 63.6 296c9.9 0 15.6-27.6 15.6-35.4 0-9.3-23.7-29.1-23.7-67.8 0-80.4 61.2-137.4 140.4-137.4 68.1 0 118.5 38.7 118.5 109.8 0 53.1-21.3 152.7-90.3 152.7-24.9 0-46.2-18-46.2-43.8 0-37.8 26.4-74.4 26.4-113.4 0-66.2-93.9-54.2-93.9 25.8 0 16.8 2.1 35.4 9.6 50.7-13.8 59.4-42 147.9-42 209.1 0 18.9 2.7 37.5 4.5 56.4 3.4 3.8 1.7 3.4 6.9 1.5 50.4-69 48.6-82.5 71.4-172.8 12.3 23.4 44.1 36 69.3 36 106.2 0 153.9-103.5 153.9-196.8C384 71.3 298.2 6.5 204 6.5z" />
      </svg>
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="resp-sharing-button__link" title="WhatsApp" href="'.$whatsappURL.'" target="_blank" rel="nofollow noopener" aria-label="">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
         <path d="M20.1 3.9C17.9 1.7 15 .5 12 .5 5.8.5.7 5.6.7 11.9c0 2 .5 3.9 1.5 5.6L.6 23.4l6-1.6c1.6.9 3.5 1.3 5.4 1.3 6.3 0 11.4-5.1 11.4-11.4-.1-2.8-1.2-5.7-3.3-7.8zM12 21.4c-1.7 0-3.3-.5-4.8-1.3l-.4-.2-3.5 1 1-3.4L4 17c-1-1.5-1.4-3.2-1.4-5.1 0-5.2 4.2-9.4 9.4-9.4 2.5 0 4.9 1 6.7 2.8 1.8 1.8 2.8 4.2 2.8 6.7-.1 5.2-4.3 9.4-9.5 9.4zm5.1-7.1c-.3-.1-1.7-.9-1.9-1-.3-.1-.5-.1-.7.1-.2.3-.8 1-.9 1.1-.2.2-.3.2-.6.1s-1.2-.5-2.3-1.4c-.9-.8-1.4-1.7-1.6-2-.2-.3 0-.5.1-.6s.3-.3.4-.5c.2-.1.3-.3.4-.5.1-.2 0-.4 0-.5C10 9 9.3 7.6 9 7c-.1-.4-.4-.3-.5-.3h-.6s-.4.1-.7.3c-.3.3-1 1-1 2.4s1 2.8 1.1 3c.1.2 2 3.1 4.9 4.3.7.3 1.2.5 1.6.6.7.2 1.3.2 1.8.1.6-.1 1.7-.7 1.9-1.3.2-.7.2-1.2.2-1.3-.1-.3-.3-.4-.6-.5z" />
      </svg>
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="resp-sharing-button__link" title="VK" href="'.$vkURL.'" target="_blank" rel="nofollow noopener" aria-label="">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
      <path d="M21.547 7h-3.29a.743.743 0 0 0-.655.392s-1.312 2.416-1.734 3.23C14.734 12.813 14 12.126 14 11.11V7.603A1.104 1.104 0 0 0 12.896 6.5h-2.474a1.982 1.982 0 0 0-1.75.813s1.255-.204 1.255 1.49c0 .42.022 1.626.04 2.64a.73.73 0 0 1-1.272.503 21.54 21.54 0 0 1-2.498-4.543.693.693 0 0 0-.63-.403h-2.99a.508.508 0 0 0-.48.685C3.005 10.175 6.918 18 11.38 18h1.878a.742.742 0 0 0 .742-.742v-1.135a.73.73 0 0 1 1.23-.53l2.247 2.112a1.09 1.09 0 0 0 .746.295h2.953c1.424 0 1.424-.988.647-1.753-.546-.538-2.518-2.617-2.518-2.617a1.02 1.02 0 0 1-.078-1.323c.637-.84 1.68-2.212 2.122-2.8.603-.804 1.697-2.507.197-2.507z" />
   </a>
</li>
';
        $content1 .= '
<li class="mr-2">
   <a class="resp-sharing-button__link" title="Telegram" href="'.$telegramURL.'" target="_blank" rel="nofollow noopener" aria-label="">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
         <path d="M.707 8.475C.275 8.64 0 9.508 0 9.508s.284.867.718 1.03l5.09 1.897 1.986 6.38a1.102 1.102 0 0 0 1.75.527l2.96-2.41a.405.405 0 0 1 .494-.013l5.34 3.87a1.1 1.1 0 0 0 1.046.135 1.1 1.1 0 0 0 .682-.803l3.91-18.795A1.102 1.102 0 0 0 22.5.075L.706 8.475z" />
      </svg>
   </a>
</li>
';
        $content1 .= '</ul>';
        return $content1;
    } else {
        #### if not a post/page then don't include sharing button
        return $content1;
    }
};
add_filter( 'the_content1', 'ex_themes_blog_shares_');
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
//change text to leave a reply on comment form
function moddroid_comments_1 ($arg) {
global $opt_themes;
$arg['title_reply'] = '';
return $arg;
}
add_filter('comment_form_defaults','moddroid_comments_1');

function moddroid_comments_2($arg) {
global $opt_themes;
$arg['label_submit'] = $opt_themes['exthemes_comments_2'];
return $arg;
}
add_filter('comment_form_defaults', 'moddroid_comments_2');
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function filter_comment_form_submit_button( $submit_button, $args ) {
    $submit_before = '<div class="form-group text-right">';
    $submit_after = '</div>';
    return $submit_before . $submit_button . $submit_after;
};
add_filter( 'comment_form_submit_button', 'filter_comment_form_submit_button', 10, 2 );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function my_post_time_ago_function() {
	global $opt_themes;
	$agos = $opt_themes['exthemes_apk_ago'];
    return sprintf( esc_html__( '%s '.$agos.'', 'moddroid' ), human_time_diff(get_the_time ( 'U' ), current_time( 'timestamp' ) ) );
}
add_filter( 'the_time', 'my_post_time_ago_function' );
function my_comment_time_ago_function() {
	global $opt_themes;
	$agos = $opt_themes['exthemes_apk_ago'];
    return sprintf( esc_html__( '%s '.$agos.'', 'moddroid' ), human_time_diff(get_comment_time ( 'U' ), current_time( 'timestamp' ) ) );
}
add_filter( 'get_comment_date', 'my_comment_time_ago_function' );
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_clean($string) {
   $string = str_replace(' ', '-', $string); // Replaces all spaces with hyphens.
   $string = preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
   return preg_replace('/-+/', '-', $string); // Replaces multiple hyphens with single one.
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
remove_filter( 'sanitize_title', 'sanitize_title_with_dashes', 10 );
add_filter( 'sanitize_title', 'wpse231448_sanitize_title_with_dashes', 10, 3 );
function wpse231448_sanitize_title_with_dashes( $title, $raw_title = '', $context = 'display' ) {
    $title = strip_tags($title);
    $title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
    $title = str_replace('%', '', $title);
    $title = preg_replace('|---([a-fA-F0-9][a-fA-F0-9])---|', '%$1', $title);
    if (seems_utf8($title)) {
        if (function_exists('mb_strtolower')) {
            $title = mb_strtolower($title, 'UTF-8');
        }
        $title = utf8_uri_encode($title, 200);
    }
    $title = strtolower($title);
    if ( 'save' == $context ) {
        $title = str_replace( array( '%c2%a0', '%e2%80%93', '%e2%80%94' ), '-', $title );
        $title = str_replace( array( '&nbsp;', '&#160;', '&ndash;', '&#8211;', '&mdash;', '&#8212;' ), '-', $title );
        $title = str_replace( array(
            // iexcl and iquest
            '%c2%a1', '%c2%bf',
            // angle quotes
            '%c2%ab', '%c2%bb', '%e2%80%b9', '%e2%80%ba',
            // curly quotes
            '%e2%80%98', '%e2%80%99', '%e2%80%9c', '%e2%80%9d',
            '%e2%80%9a', '%e2%80%9b', '%e2%80%9e', '%e2%80%9f',
            // copy, reg, deg, hellip and trade
            '%c2%a9', '%c2%ae', '%c2%b0', '%e2%80%a6', '%e2%84%a2',
            // acute accents
            '%c2%b4', '%cb%8a', '%cc%81', '%cd%81',
            // grave accent, macron, caron
            '%cc%80', '%cc%84', '%cc%8c',
        ), '', $title );
        // Convert times to x
        $title = str_replace( '%c3%97', 'x', $title );
    }
    $title = preg_replace('/&.+?;/', '', $title); 
    // WPSE-231448: Commented out this line below to stop dots being replaced by dashes.
    //$title = str_replace('.', '-', $title);
    // WPSE-231448: Add the dot to the list of characters NOT to be stripped.
    $title = preg_replace('/[^%a-z0-9 _\-\.]/', '', $title);
    $title = preg_replace('/\s+/', '-', $title);
    $title = preg_replace('|-+|', '-', $title);
    $title = trim($title, '-');
    return $title;
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\
function ex_themes_post_gallery_contents_($content2) {
    global $wpdb, $post, $opt_themes;
    if(is_singular() || is_home()){
        $ex_themes_page_titles_ = esc_html( get_post_meta( $post->ID, 'wp_title_GP', true ) );
		$ex_themes_datos_imagenes = get_post_meta(get_the_ID(), 'wp_images_GP', true);
        $ex_themes_if_ = get_post_meta( $post->ID, 'wp_images_GP', true );
        $content2 .= "<div id=\"gallery-3\" class=\"gallery galleryid-28459 gallery-columns-3 gallery-size-medium\">";
		if (get_post_meta( $post->ID, 'wp_images_GP', true )) {
        $datos_imagenes = $ex_themes_datos_imagenes;
        $i = 0;
		if(count($datos_imagenes)>3){
         foreach($datos_imagenes as $elemento) { 
		 $content2 .= "<style type=\"text/css\">#gallery-3{margin:auto}#gallery-3 .gallery-item{float:left;margin-top:10px;text-align:center;width:33%}#gallery-3 img{border:2px solid #cfcfcf}#gallery-3 .gallery-caption{margin-left:0}</style>";
        $content2 .= "<dl class=\"gallery-item\">";
        $content2 .= "<dt class=\"gallery-icon portrait\">";
		$content2 .= "<img src=\"";
		$content2 .= $datos_imagenes[$i];
		$content2 .= "\" data-spai=\"1\" class=\"attachment-medium size-medium\" title=\"";
		$content2 .= $ex_themes_page_titles_;
		$content2 .= "screen ";
		$content2 .= $i;
		$content2 .= "\" data-spai-upd=\"212\" width=\"226\" height=\"402\">";
        $content2 .= "</dt>";
        $content2 .= "</dl>";
        if (++$i == 3) break; } } } 
        $content2 .= "<br style=\"clear: both\">";
        $content2 .= "</div>";		 
        return $content2;
		} else {
        #### if not a post/page then don't include sharing button
        return $content2;
    }
};
add_filter( 'the_content2', 'ex_themes_post_gallery_contents_');
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\ 
add_filter( 'the_content2', 'ex_themes_post_gallery_contents_insert_' ); 
function ex_themes_post_gallery_contents_insert_( $content2 ) {  
	global $opt_themes;
    $activate = $opt_themes['ex_themes_gallery_content_activate_'];
    $numbers = $opt_themes['ex_themes_gallery_content_paragraph_on_'];
    if (($activate == '1'))           
    $ex_themes_post_gallery_contents_code_ = ex_themes_post_gallery_contents_($content2); 
    if ( is_single() && ! is_admin() ) {
        return ex_themes_post_gallery_contents_after_paragraph_( $ex_themes_post_gallery_contents_code_, $numbers, $content2 );
    }     
    return $content2;
}  
function ex_themes_post_gallery_contents_after_paragraph_( $insertion, $paragraph_id, $content2 ) {
    $closing_p = '</p>';
    $paragraphs = explode( $closing_p, $content2 );
    foreach ($paragraphs as $index => $paragraph) { 
        if ( trim( $paragraph ) ) {
            $paragraphs[$index] .= $closing_p;
        } 
        if ( $paragraph_id == $index + 1 ) {
            $paragraphs[$index] .= $insertion;
        }
    }     
    return implode( '', $paragraphs );
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\ 
function ex_themes_post_youtube_contents_($content2) {
    global $wpdb, $post, $opt_themes;
    if(is_singular() || is_home()){
        $ex_themes_page_titles_ = esc_html( get_post_meta( $post->ID, 'wp_title_GP', true ) );
		$ex_themes_datos_youtube = get_post_meta(get_the_ID(), 'wp_youtube_GP', true);
        $ex_themes_if_ = get_post_meta( $post->ID, 'wp_youtube_GP', true );
		if (get_post_meta( $post->ID, 'wp_youtube_GP', true )) {
        $content2 .= "<center>";		 
        $datos_youtube = $ex_themes_datos_youtube;
		$content2 .= "<iframe src=\"https://www.youtube.com/embed/";
		$content2 .= $datos_youtube;
		$content2 .= "\" data-spai=\"1\" class=\"attachment-medium size-medium\" title=\"";
		$content2 .= $ex_themes_page_titles_;
		$content2 .= "screen ";
		//$content2 .= $i;
		$content2 .= "\" allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture\" frameborder=\"0\" allowfullscreen=\"allowfullscreen\" width=\"100%\" height=\"400px\"></iframe>";
        $content2 .= "<br style=\"clear: both\">";
        $content2 .= "</center>";	
		}		
        return $content2;
		 
        #### if not a post/page then don't include sharing button
        return $content2;
    }
};
add_filter( 'the_content2', 'ex_themes_post_youtube_contents_');
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\ 
add_filter( 'the_content', 'ex_themes_post_youtube_contents_insert_' ); 
function ex_themes_post_youtube_contents_insert_( $content ) {  
	global $opt_themes;
    $activate = $opt_themes['ex_themes_youtube_content_activate_'];
    $numbers = $opt_themes['ex_themes_youtube_content_paragraph_on_'];
    if (($activate == '1'))           
    $ex_themes_post_youtube_contents_code_ = ex_themes_post_youtube_contents_($content2); 
    if ( is_single() && ! is_admin() ) {
        return ex_themes_post_youtube_contents_after_paragraph_( $ex_themes_post_youtube_contents_code_, $numbers, $content );
    }     
    return $content;
}  
function ex_themes_post_youtube_contents_after_paragraph_( $insertion, $paragraph_id, $content ) {
    $closing_p = '</p>';
    $paragraphs = explode( $closing_p, $content );
    foreach ($paragraphs as $index => $paragraph) { 
        if ( trim( $paragraph ) ) {
            $paragraphs[$index] .= $closing_p;
        } 
        if ( $paragraph_id == $index + 1 ) {
            $paragraphs[$index] .= $insertion;
        }
    }     
    return implode( '', $paragraphs );
}
// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\ 
add_filter('upload_mimes', 'allow_custom_mimes');
function allow_custom_mimes ( $existing_mimes=array() ) {
	$existing_mimes['apk'] = '<code>application/vnd.android.package-archive</code>';
	return $existing_mimes;
}

// ~~~~~~~~~~~~~~~~~~~~~ EX_THEMES ~~~~~~~~~~~~~~~~~~~~~~~~ \\ 
###### this code for apkdone, 5play and moddroid themes ######
###### Open your apk themes –> functions.php and insert this code on end line ######
function exthemes_download_page__noindex_nofollow()
{
	global $wp_query;
	$noindex = "<meta name='robots' content='noindex,follow' />\n";
	if ( ! isset( $wp_query->query_vars['download'] ) || ! is_singular() ) {
		return;
	}
	echo $noindex;
}
add_action( 'wp_head', 'exthemes_download_page__noindex_nofollow',1); 

function exthemes_get_page__noindex_nofollow()
{
	global $wp_query;
	$noindex = "<meta name='robots' content='noindex,follow' />\n";
	if ( ! isset( $wp_query->query_vars['get'] ) || ! is_singular() ) {
		return;
	}
	echo $noindex;
}
add_action( 'wp_head', 'exthemes_get_page__noindex_nofollow',1); 

function exthemes_get_files__noindex_nofollow()
{
	global $wp_query;
	$noindex = "<meta name='robots' content='noindex,follow' />\n";
	if ( ! isset( $wp_query->query_vars['file'] ) || ! is_singular() ) {
		return;
	}
	echo $noindex;
}
add_action( 'wp_head', 'exthemes_get_files__noindex_nofollow',1); 

 
add_filter( 'get_the_excerpt', 'exthemes_excerpt_more' );
function exthemes_excerpt_more( $excerpt ) {
    return substr( $excerpt, 0, 27 ) . '...';
}