<?php
/**
 * Merlin WP configuration file.
 *
 * @package   Merlin WP
 * @version   @@pkg.version
 * @link      https://merlinwp.com/
 * @author    Rich Tabor, from ThemeBeans.com & the team at ProteusThemes.com
 * @copyright Copyright (c) 2018, Merlin WP of Inventionn LLC
 * @license   Licensed GPLv3 for Open Source Use
 */

if ( ! class_exists( 'Merlin' ) ) {
	return;
}

/**
 * Set directory locations, text strings, and settings.
 */
$wizard = new Merlin(

	$config = array(
		'directory'            => 'libs/merlin', 
		'merlin_url'           => 'exthemes-wizard', 
		'parent_slug'          => 'themes.php', 
		/* 'capability'           => 'manage_options',  */
		'child_action_btn_url' => 'https://codex.wordpress.org/child_themes', 
		'dev_mode'             => true, 
		'license_step'         => true, 
		'license_required'     => true, 
		'license_help_url'     => EXTHEMES_MEMBER_URL, 
		'edd_remote_api_url'   => EXTHEMES_API_URL,  
		'edd_item_name'        => EXTHEMES_NAME, 
		'edd_theme_slug'       => EXTHEMES_SLUG, 
		/* 'ready_big_button_url' => '',  */
	),
	$strings = array(
		'admin-menu'               => esc_html__( 'Import Demos '.EX_THEMES_NAMES_.'', 'exthemes' ),

		/* translators: 1: Title Tag 2: Theme Name 3: Closing Title Tag */
		'title%s%s%s%s'            => esc_html__( '%1$s%2$s Themes &lsaquo; Theme Setup: %3$s%4$s', 'exthemes' ),
		'return-to-dashboard'      => esc_html__( 'Return to the dashboard', 'exthemes' ),
		'ignore'                   => esc_html__( 'Disable '.EX_THEMES_NAMES_.' wizard', 'exthemes' ),

		'btn-skip'                 => esc_html__( 'Skip', 'exthemes' ),
		'btn-next'                 => esc_html__( 'Next', 'exthemes' ),
		'btn-start'                => esc_html__( 'Start', 'exthemes' ),
		'btn-no'                   => esc_html__( 'Cancel', 'exthemes' ),
		'btn-plugins-install'      => esc_html__( 'Install', 'exthemes' ),
		'btn-child-install'        => esc_html__( 'Install', 'exthemes' ),
		'btn-content-install'      => esc_html__( 'Install', 'exthemes' ),
		'btn-import'               => esc_html__( 'Import', 'exthemes' ),
		'btn-license-activate'     => esc_html__( 'Activate', 'exthemes' ),
		'btn-license-skip'         => esc_html__( 'Later', 'exthemes' ),

		/* translators: Theme Name */
		'license-header%s'         => esc_html__( 'Activate %s', 'exthemes' ),
		/* translators: Theme Name */
		'license-header-success%s' => esc_html__( '%s is Activated', 'exthemes' ),
		/* translators: Theme Name */
		'license%s'                => esc_html__( 'Enter your license key and double click or Click 2x Activate Button', 'exthemes' ),
		'license-label'            => esc_html__( 'License key', 'exthemes' ),
		'license-success%s'        => esc_html__( 'The theme is already registered, so you can go to the next step!', 'exthemes' ),
		'license-json-success%s'   => esc_html__( 'Your theme is activated! Remote updates and theme support are enabled.', 'exthemes' ),
		'license-tooltip'          => esc_html__( 'Need help?', 'exthemes' ),

		/* translators: Theme Name */
		'welcome-header%s'         => esc_html__( 'Welcome to %s', 'exthemes' ),
		'welcome-header-success%s' => esc_html__( 'Hi. Welcome back', 'exthemes' ),
		'welcome%s'                => esc_html__( 'This wizard will set up '.EX_THEMES_NAMES_.' theme, install plugins, and import content. It is optional & should take only a few minutes.', 'exthemes' ),
		'welcome-success%s'        => esc_html__( 'You may have already run '.EX_THEMES_NAMES_.' theme setup wizard. If you would like to proceed anyway, click on the "Start" button below.', 'exthemes' ),

		'child-header'             => esc_html__( 'Install '.EX_THEMES_NAMES_.' Child Theme', 'exthemes' ),
		'child-header-success'     => esc_html__( 'You\'re good to go!', 'exthemes' ),
		'child'                    => esc_html__( 'Let\'s build & activate a child theme so you may easily make theme changes.', 'exthemes' ),
		'child-success%s'          => esc_html__( 'Your child theme has already been installed and is now activated, if it wasn\'t already.', 'exthemes' ),
		'child-action-link'        => esc_html__( 'Learn about child themes', 'exthemes' ),
		'child-json-success%s'     => esc_html__( 'Awesome. Your child theme has already been installed and is now activated.', 'exthemes' ),
		'child-json-already%s'     => esc_html__( 'Awesome. Your child theme has been created and is now activated.', 'exthemes' ),

		'plugins-header'           => esc_html__( 'Install Plugins', 'exthemes' ),
		'plugins-header-success'   => esc_html__( 'You\'re up to speed!', 'exthemes' ),
		'plugins'                  => esc_html__( 'Let\'s install some essential WordPress plugins to get your site up to speed.', 'exthemes' ),
		'plugins-success%s'        => esc_html__( 'The required WordPress plugins are all installed and up to date. Press "Next" to continue the setup wizard.', 'exthemes' ),
		'plugins-action-link'      => esc_html__( 'Advanced', 'exthemes' ),

		'import-header'            => esc_html__( 'Import Demo Content ', 'exthemes' ),
		'import'                   => esc_html__( 'Let\'s import content to your website, to help you get familiar with the theme.Choose Your Preferred demo from below.', 'exthemes' ),
		'import-action-link'       => esc_html__( 'Advanced', 'exthemes' ),

		'ready-header'             => esc_html__( 'All done. Have fun!', 'exthemes' ),

		/* translators: Theme Author */
		'ready%s'                  => esc_html__( 'Your theme has been all set up. Enjoy your new theme by %s.', 'exthemes' ),
		'ready-action-link'        => esc_html__( 'Extras', 'exthemes' ),
		'ready-big-button'         => esc_html__( 'View your website', 'exthemes' ),
		'ready-link-1'             => sprintf( '<a href="%1$s" target="_blank">%2$s</a>', 'https://wordpress.org/support/', esc_html__( 'Explore WordPress', 'exthemes' ) ),
		'ready-link-2'             => sprintf( '<a href="%1$s" target="_blank">%2$s</a>', 'https://exthem.es', esc_html__( 'Get Theme Support', 'exthemes' ) ),
		'ready-link-3'             => sprintf( '<a href="%1$s">%2$s</a>', admin_url( 'customize.php' ), esc_html__( 'Start Customizing', 'exthemes' ) ),
	)
);
