<?php
/* 
Template Name: Template - Popular Apps
*/
get_header(); // add header ?>
    <div id="content" class="site-content">
        <div class="py-2"><br>
            <div class="container py-1">
                <ul id="breadcrumb" class="breadcrumb">
                    <li class="breadcrumb-item home"><a href="<?php echo esc_url( home_url( '/' ) ); ?>" title="Home">Home</a></li>
                    <li class="breadcrumb-item home"><?php the_title(); ?></li>
                </ul>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <main id="primary" class="col-12 col-lg-8 content-area">
                    <h1 class="h5 font-weight-semibold mb-3">
               <span class="border-bottom-2 border-secondary d-inline-block pb-1">
               <?php the_title(); ?>
               </span>
                    </h1>
             
                    <div class="mb-4 entry-content">
                        <p>Discover thousands of unique mobile <?php the_title(); ?>. We are constantly updating daily, along with the best mods available here</p>
                    </div>
                    <div class="row">
                        <?php
                        global $opt_themes;
                        $paged_categorie_apps = (get_query_var('paged')) ? get_query_var('paged') : 1;
                        $cat_ID_categorie_apps = $opt_themes['categorie_tops_apps'];
                        $limited_categorie_apps = $opt_themes['limit_categorie'];
                        $today = date('Y-m-d h:i:s');
                        $one_week_ago = date('Y-m-d', strtotime($today . ' - 7 days'));
                        query_posts( array(
                                /*'date_query' => array(
                               array(
                               'before' => $today,
                               'after' => $one_week_ago,
                               'inclusive' => true
                               ),
                             ),*/
                                'paged' => $paged_categorie_apps,
                                'cat' => $cat_ID_categorie_apps,
                                'posts_per_page' => $limited_categorie_apps,
                                'meta_key' => 'post_views_count',
                                'orderby' => 'meta_value_num',
                                'order' => 'DESC' )
                        );
                        if (have_posts()) : while (have_posts()) : the_post();
                            ?>
			<?php get_template_part('template/loop.item'); ?>
                        <?php endwhile; ?>
                            <?php wp_reset_postdata(); ?>
                        <?php endif; ?>
                    </div>
                    <nav class="nav-pagination">
                        <ul class="pagination">
                            <?php ex_themes_page_navy_(); ?>
                        </ul>
                    </nav>
                    <div class="mb-4">
                        <?php ex_themes_banner_header_ads_2(); ?>
                    </div>
                </main>
                <!--sidebar-->
                <aside id="secondary" class="col-12 col-lg-4 widget-area">
                    <?php get_sidebar(); ?>
                </aside>
                <!--sidebar-->
            </div>
            <?php get_template_part('template/breadcrumbs'); ?>
        </div>
    </div>
<?php get_footer(); ?>